Dim FlameFrames(MaxFlameFrames)
Global dt

Graphics3D 1280,1024,32,1;640,480,32,2
SetBuffer BackBuffer()

cam = CreateCamera()

LoadFlameFrames("flame", ".jpg")

For i=0 To 100
	CreateFlame(Rand(-20,20),0,Rand(8,12))
Next

Nadpis = LoadMesh("nadpis.3ds")
EntityBlend Nadpis,3
EntityFX Nadpis, 16
FireTexture = LoadTexture("firegorre2.jpg")
EntityTexture Nadpis,FireTexture
PositionEntity nadpis,-1,1,7
ScaleEntity nadpis,.07,.1,.1

Nadpis2 = CopyMesh(Nadpis)
AddMesh Nadpis2, Nadpis
FreeEntity Nadpis2


Fx# = 0
Fy#=0

Repeat
cycletime = MilliSecs()

Fx = Fx + 0.001*dt
Fy = Fy + 0.001*dt

PositionTexture FireTexture, fx,0

UpdateFlame()
RenderWorld()

Flip

dt = MilliSecs() - cycletime
Until KeyHit(1)

End

; =====   

Const MaxFlameFrames = 7
Const FlameChangeTime = 60

Type Flame
	Field Sprite
	Field ChangeTime
	Field Frame
End Type

Function LoadFlameFrames(filename$, ras$ = ".jpg")
	For i=0 To MaxFlameFrames
		FlameFrames(i) = LoadTexture(filename+i+ras$)
	Next
End Function

Function CreateFlame(x#,y#,z#)
	F.Flame = New Flame
	F\ChangeTime = Rand(0,100)
	F\Frame = Rand(0, MaxFlameFrames)
	F\Sprite = CreateSprite()
	Scale# = Rnd(1,3)
	ScaleSprite F\Sprite,1*Scale,2*Scale
	EntityBlend F\Sprite,3
	SpriteViewMode F\Sprite,4
	PositionEntity F\Sprite, x,y,z
End Function

Function UpdateFlame()
	For F.Flame = Each Flame
		If F\ChangeTime + FlameChangeTime < MilliSecs() Then 
			F\Frame = F\Frame + 1
			If F\Frame > MaxFlameFrames Then F\Frame = 0
			EntityTexture F\Sprite,FlameFrames(F\Frame)
			F\ChangeTime = MilliSecs()
		End If
	Next
End Function